
/* 
 * ProbView.h -- Interface file for the ProbView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, or even that there is a use for it.
 *
 */

#import <appkit/appkit.h>

@interface ProbView:View {

	id		gridSize;
	id		ruleNumber;
	id		pslid;
	id		tiDat;

	id		theBlockView;
	id		theProbView;
	id		theStereoView;

	id		keyWindow;
	id		blockWindow;
	id		probWindow;
	id		stereoWindow;
	
	id		nblokAve;
	id		nblokLen;
	id		probEI;
	id		probGens;
	id		probGrid;
	id		probComp;
	id		probLevel;
	id		probView;
	id		pswit;

	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		crossCursor;
}

- loadProb:sender;

- copyBlock:sender;
- copyEntropy:sender;
- copyNBlock:sender;
- copyPlaid:sender;
- copyProb:sender;
- copyStereo:sender;

- drawMeanF:sender;
- drawNBlock:sender;
- drawStereo:sender;

- printStereo:sender;
- printMeanF:sender;
- printNBlock:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end ProbView.h */
