
/* nxardn4t.c						*/
/* program for lcau4t option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau4t.h"
# include "nxardn4t.h"

extern parneih    amat;
extern parneih    bmat;
extern parneih    cmat;
extern parneih    fmat;
extern parneih    gmat;
extern parneih    hmat;
extern parneih    xmat;

extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

extern int  binrule[KK][KK][KK][KK];

# define K1	KK

int  h8[HH];

/* edit the Garden of Eden and ancestor calculation */
void edard() {}

/* calculate the first two moments of all rules */
void allmo(stt,sta)
  double *stt, sta[5][K2+1][K2+1]; {}

/* calculate tensor square axa+bxb+cxc+dxd */
void tensq(tmat,amat,bmat,cmat,dmat)
 twoparn *tmat;
 parneih *amat, *bmat, *cmat, *dmat; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++)
for (i11=0; i11<KK; i11++)
  {
  tmat->twelve[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11]+=
	amat->six[i0][i1][i2][i6][i7][i8]*amat->six[i2][i3][i4][i9][i10][i11]+
	bmat->six[i0][i1][i2][i6][i7][i8]*bmat->six[i2][i3][i4][i9][i10][i11]+
	cmat->six[i0][i1][i2][i6][i7][i8]*cmat->six[i2][i3][i4][i9][i10][i11]+
	dmat->six[i0][i1][i2][i6][i7][i8]*dmat->six[i2][i3][i4][i9][i10][i11];
  }
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

/* clear edard screen and set up menu */
void clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("abc - 0,1 matrix\n");
  printf("ABC - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Q   - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ss   - all rules\n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}

void rvers(amat,bmat,cmat) parneih *amat, *bmat, *cmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
double o, q, r, s, t, u, v, w, kk1, kk2, kk3, kk4, curt(), fort();

kk1=(double)K1;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);
cymat(&m1[2],&cmat);
for (i0=0; i0<KK; i0++) t1[i0]=tsum(&m1[i0]);
// videocursor(0,2,0); printf("%3u,%3u,%3u",t1[0],t1[1],t1[2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3d,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    printf("%3d,",t3[i0][i1][i2]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&m4[i0][i1][i2][i3]);
  }
videocursor(0,10,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3d,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

q=r=s=0.0;
for (i=0; i<KK; i++) {t=((double)(t1[i]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk1); videocursor(0,20,0);  printf("%6.2f",t);
t=curt(r/kk1); videocursor(0,20,10); printf("%6.2f",t);
t=fort(q/kk1); videocursor(0,20,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {t=((double)(t2[i0][i1]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk2); videocursor(0,21,0);  printf("%6.2f",t);
t=curt(r/kk2); videocursor(0,21,10); printf("%6.2f",t);
t=fort(q/kk2); videocursor(0,21,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=u=sqrt(s/kk3); videocursor(0,22,0);  printf("%6.2f",t);
t=v=curt(r/kk3); videocursor(0,22,10); printf("%6.2f",t);
t=w=fort(q/kk3); videocursor(0,22,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk4); videocursor(0,23,0);  printf("%6.2f",t);
s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("r:%6.2f",s);
t=curt(r/kk4); videocursor(0,23,10); printf("%6.2f",t);
s=1.0; if (v!=0.0) s=t/v;
videocursor(0,24,12); printf("r:%6.2f",s);
t=fort(q/kk4); videocursor(0,23,20); printf("%6.2f",t);
s=1.0; if (w!=0.0) s=t/w;
videocursor(0,24,24); printf("r:%6.2f",s);

}

void histo(amat,bmat,cmat) parneih *amat, *bmat, *cmat; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[HH];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],&amat);
cymat(&m1[1],&bmat);
cymat(&m1[2],&cmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<HH; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {i=t8[i0][i1][i2][i3][i4][i5][i6][i7]; if (i<HH) h8[i]++;}

po=da=0;
for (i=0; i<HH; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2d %4d %4d",i,h8[i],po);
  }

videocursor(0,22,0);  printf("ttl %4d in %4d pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2d",AV);
videocursor(0,22,23); printf("beyond:%5d,%3d",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);
s=1.0; if (t>1.0) s=exp(log(t)/8.0);
videocursor(0,24,0); printf("relative sigma:   %6.2f",s);

}

double curt(z) double z; {return exp(log(z)/3.0);}

double fort(z) double z; {return exp(log(z)/4.0);}

void rever() {
int brul[KK][KK], crul[KK][KK], drul[KK][KK][KK][KK];
int erul[KK][KK][KK][KK][KK][KK];
int i0,i1,i2,i3;
int j0,j1,j2,j3,j4,j5;
int k, l;
k=l=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  brul[0][0]=i0;
  brul[0][1]=i1;
  brul[1][0]=i2;
  brul[1][1]=i3;
  if (runiq(brul,crul)) {
    printf("%3d: ",++k);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
    printf(" --- ");
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",crul[j0][j1]);
    printf("\n");
    }
  if (suniq(brul,drul)) {
    printf("%3d: ",++l);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
    printf(" ---\n");
    for (j0=0; j0<KK; j0++)
      { 
      for (j1=0; j1<KK; j1++) 
      for (j2=0; j2<KK; j2++) for (j3=0; j3<KK; j3++)
	printf("%1d",drul[j0][j1][j2][j3]);
      printf("\n");
      } /* end for */
    }   /* end if  */
  if (tuniq(brul,erul)) {
    printf("%3d: ",++l);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
    printf(" ---\n");
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++)
    for (j2=0; j2<KK; j2++)
      { 
      for (j3=0; j3<KK; j3++) 
      for (j4=0; j4<KK; j4++) for (j5=0; j5<KK; j5++)
	printf("%1d",erul[j0][j1][j2][j3][j4][j5]);
      printf("\n");
      } /* end for */
    }   /* end if  */
  }     /* end for nest */
}

int runiq(brul,crul) int brul[KK][KK], crul[KK][KK]; {
int a, b;
int j0, j1, j2;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) crul[j0][j1]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  if (crul[a][b]==KK) crul[a][b]=j1;
  if (crul[a][b]!=j1) return(0);
  }
return(1);
}

int suniq(brul,drul) int brul[KK][KK], drul[KK][KK][KK][KK]; {
int a, b, e, f;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
  drul[j0][j1][j2][j3]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  if (drul[a][b][e][f]==KK) drul[a][b][e][f]=j2;
  if (drul[a][b][e][f]!=j2) return(0);
  }
return(1);
}

int tuniq(brul,erul) int brul[KK][KK], erul[KK][KK][KK][KK][KK][KK]; {
int a, b, e, f, g, h;
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
  erul[j0][j1][j2][j3][j4][j5]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  g=brul[j4][j5];
  h=brul[j5][j6];
  if (erul[a][b][e][f][g][h]==KK) erul[a][b][e][f][g][h]=j3;
  if (erul[a][b][e][f][g][h]!=j3) return(0);
  }
return(1);
}

/* print matrix */
void pmat(z,i,j) parneih *z; int i, j; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {videocursor(0,i+i0,j+i1); printf("%1d",z->two[i0][i1]);}
}

/* print matrix */
void ppmat(z,i,j) twoparn *z; int i, j; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  videocursor(0,i+KK*i0+i1,j);
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%4d",z->four[i0][i1][i2][i3]);
  }
}

///* display K2xK2 matrix */
//void qqmat(z,i,j) twopanr *z, int i, j; {
//int i0, i1, k, l;
//for (i0=0; i0<K4; i0++)
//for (i1=0; i1<K4; i1++)
//  {
//  k=0; l=z->two[i0][i1];
//  if (l==1) k=1;
//  if (l>=2) k=2;
//  if (l>=4) k=3;
//  videodot(i+i0,j+i1,k);
//  }
//}

/* total matrix elements */
int tsum(z) parneih *z; 
{int i, t; for (i=0, t=0; i<K2; i++) t+=z->one[i]; return t;}

/* total matrix elements */
int ttsum(z) twoparn *z; 
{int i, t; for (i=0, t=0; i<K4; i++) t+=z->one[i]; return t;}

/* count nonzero matrix elements */
int nzel(z) parneih *z; 
{int i, t; for (i=0, t=0; i<K2; i++) if (z->one[i]!=0) t++; return t;}

/* count nonzero matrix elements */
int nnzel(z) twoparn *z; 
{int i, t; for (i=0, t=0; i<K4; i++) if (z->one[i]!=0) t++; return t;}

/* calculate row sums */
void rowsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (i0=0; i0<KK; i0++) {
  x[i0]=0;
  for (j0=0; j0<KK; j0++) x[i0]+=z->two[i0][j0];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (j0=0; j0<KK; j0++) {
  x[j0]=0;
  for (i0=0; i0<KK; i0++) x[j0]+=z->two[i0][j0];
  }
}

/* copy one KKxKK matrix from another: z=x */
void cymat(z,x) parneih *z, *x; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->two[i0][i1]=x->two[i0][i1];
}

/* copy one K2xK2 matrix from another: z=x */
void ccymat(z,x) twoparn *z, *x; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z->four[i0][i1][i2][i3]=x->four[i0][i1][i2][i3];
}

/* multiply KKxKK matrices */
void mmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply transpose of first matrix by second */
void mtmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* multiply K2xK2 matrices */
void mmmat(z,x,y) twoparn *z, *x, *y; {
int i0, i1, i2, i3, i4, i5;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      {
      z->four[i0][i1][i4][i5]=0;
      for (i2=0; i2<KK; i2++)
      for (i3=0; i3<KK; i3++)
	z->four[i0][i1][i4][i5]+=
	x->four[i0][i1][i2][i3]*y->four[i2][i3][i4][i5];
      }
}

/* multiply transpose of first K2xK2 matrix by second */
void mmtmat(z,x,y) twoparn *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<K2; i0++)
    for (i2=0; i2<K2; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) int l; parneih *z; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->two[i0][i1]=(binrule[i0][i1]==l)?1:0;
}

/* zero a KKxKK matrix */
void zmat(z) parneih *z; {int i; for (i=0; i<K2; i++) z->one[i]=0;}

/* generate a K2xK2 unit matrix */
void unmat(z) twoparn *z; {
int i0, i1;
  zzmat(z);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->four[i0][i1][i0][i1]=1;
}

/* zero a K2xK2 matrix */
void zzmat(z) twoparn *z; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z->four[i0][i1][i2][i3]=0;
}

/* average and variance of eigenvector components */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 twoparn *mat; {
int    i, j;
double a, v, p, q, r, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[j][i];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
for (i=0; i<K2; i++) vec[i]/=a;
a=1.0/kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K2; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk2);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; twoparn *mat; {
int    i, j;
double a, v, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[i][j];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
a/=kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk2);
}


/* end  nxardn4t.c */
